#!/bin/bash
#### "***********************************************"
#### "*       ..:: Script by MOHAMED_OS ::..        *"
#### "*  Support: https://github.com/MOHAMED19OS    *"
#### "*       E-Mail: mohamed19eng@gmail.com        *"
#### "***********************************************"
FIN="<--------------------------------------------->"

#### Binary File ####
BIN_FILES="oscam"
BIN="OSCam_11789-r801"

##### Path File #####
TMPDIR="/tmp/DzOSat"
CONFIGPATH='/etc/tuxbox/config'

##### Bianry Path #####
BIN_AARCH64="${TMPDIR}/AARCH64/${BIN}"
BIN_ARM="${TMPDIR}/ARM/${BIN}"
BIN_MIPS="${TMPDIR}/MIPS/${BIN}"

#### checking your device and bin file #####
echo ${FIN}
echo ":I'm checking your device processor ..."

if uname -m | grep -qs armv7l; then
    echo ":Your Device IS ARM processor ..."
    if [ ! -f ${BIN_ARM} ]; then
        echo "Bin file Missing :("
    else
        mv -f ${BIN_ARM} ${TMPDIR} >/dev/null 2>&1
    fi
elif uname -m | grep -qs aarch64; then
    echo ":Your Device IS AARCH64 processor ..."
    if [ ! -f ${BIN_AARCH64} ]; then
        echo "Bin file Missing :("
    else
        mv -f ${BIN_AARCH64} ${TMPDIR} >/dev/null 2>&1
    fi
elif uname -m | grep -qs mips; then
    echo ":Your Device IS MIPS processor ..."
    if [ ! -f ${BIN_MIPS} ]; then
        echo "Bin file Missing :("
    else
        mv -f ${BIN_MIPS} ${TMPDIR} >/dev/null 2>&1
    fi
elif uname -m | grep -qs 7401c0; then # dm800 clone
    echo ":Your Device IS dm800 clone processor ..."
    if [ ! -f ${BIN_MIPS} ]; then
        echo "Bin file Missing :("
    else
        mv -f ${BIN_MIPS} ${TMPDIR} >/dev/null 2>&1
    fi
else
    echo "Sorry, your device does not have the proper Emu :("
    rm -rf ${TMPDIR} >/dev/null 2>&1
    exit 1
fi

####
if [ -r /usr/lib/enigma2/python/Plugins/Extensions/DreamOSatcamManager ]; then
    echo "DreamOSat camManager"
    cp -rf ${TMPDIR}/DreamOSat/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1

#### OE2.5 ####
elif [ -e /etc/apt/sources.list.d/gp4-unstable-all-feed.list ]; then
    echo "GP4 image"
    cp -rf ${TMPDIR}/GP4/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif [ -e /usr/lib/enigma2/python/Plugins/Bp/geminimain ]; then
    echo "GP3 image"
    cp -rf ${TMPDIR}/dddemon/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif grep -qs -i "OoZooN" /etc/image-version; then
    echo "OoZooN image"
    cp -rf ${TMPDIR}/oozoon/* / >/dev/null 2>&1
    if [ ! -r /usr/bin/camd ]; then
        mkdir -p /usr/bin/camd >/dev/null 2>&1
    fi
    cp -rf ${TMPDIR}/${BIN} /usr/camd/ >/dev/null 2>&1
elif grep -qs -i "newnigma2" /etc/image-version; then
    echo "newnigma2 image"
    cp -rf ${TMPDIR}/newnigma2/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif grep -qs -i "deb http://debfeed4.merlin.xyz" cat /etc/apt/sources.list; then
    echo "Merlin4 OE2.5 image"
    cp -rf ${TMPDIR}/Merlin4/* / >/dev/null 2>&1
    if [ ! -r /usr/bin/cam ]; then
        mkdir -p /usr/bin/cam >/dev/null 2>&1
    fi
    cp -rf ${TMPDIR}/${BIN} /usr/bin/cam/ >/dev/null 2>&1
elif [ -r /usr/lib/enigma2/python/Plugins/Extensions/AddOnManager ]; then
    echo "Merlin3 image"
    cp -rf ${TMPDIR}/Merlin4/* / >/dev/null 2>&1
    if [ ! -r /usr/bin/cam ]; then
        mkdir -p /usr/bin/cam >/dev/null 2>&1
    fi
    cp -rf ${TMPDIR}/${BIN} /usr/bin/cam/ >/dev/null 2>&1
elif grep -qs -i "deb http://feed.dream-elite.net" cat /etc/apt/sources.list.d/all-feed.list; then
    echo "Dream-Elite OE2.5 image"
    if [ ! -d /var/bin ]; then
        ln -sfn /usr/bin /var/bin
    fi
    cp -rf ${TMPDIR}/dreamelite2/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
    touch /etc/DExtra
elif [ -r /usr/lib/enigma2/python/DE ]; then
    echo "Dream-Elite image"
    if [ ! -d /var/bin ]; then
        ln -sfn /usr/bin /var/bin
    fi
    cp -rf ${TMPDIR}/dreamelite/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif grep -qs -i "Power-Sat" /etc/issue.net; then
    echo "PowerSat image"
    cp -rf ${TMPDIR}/PowerSat/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif grep -qs -i "SatLodge" /etc/issue.net; then
    echo "SatLodge image"
    cp -rf ${TMPDIR}/SatLodge/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
elif grep -qs -i "Peter" /etc/issue.net; then
    echo "PeterPan image"
    cp -rf ${TMPDIR}/PeterPan/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
    if [ -f /usr/ppteam/.emulist ]; then
        if ! grep -qs -i "${BIN}" /usr/ppteam/.emulist; then
            sed -i "1i 10\*${BIN}.pp\* ${BIN} \*" /usr/ppteam/.emulist
        fi
    else
        echo "10\*${BIN}.pp\* ${BIN} \*" >/usr/ppteam/.emulist
    fi
elif [ -r /usr/lib/enigma2/python/Plugins/Extensions/Blue_Panel ]; then
    echo "Demonisat image"
    cp -rf ${TMPDIR}/demonisat/* / >/dev/null 2>&1
    cp -rf ${TMPDIR}/${BIN} /usr/bin/ >/dev/null 2>&1
    systemctl daemon-reload
else
    rm -r ${TMPDIR} >/dev/null 2>&1
    echo "No emu script to this image now .. ask about it :("
    rm -rf /tmp/enigma2-plugin-softcams-oscam*.deb
    exit 1
fi

#### Checking Config Files ####
if [ ! -d ${CONFIGPATH} ]; then
    mkdir -p ${CONFIGPATH} >/dev/null 2>&1
fi

echo ${FIN}
echo ":I'm checking your config OSCam ..."
for file in ${BIN_FILES}.conf ${BIN_FILES}.dvbapi ${BIN_FILES}.provid ${BIN_FILES}.server ${BIN_FILES}.services ${BIN_FILES}.user CCcam.cfg; do
    if [ ! -f "${CONFIGPATH}/${file}" ]; then
        cp -f "${TMPDIR}${CONFIGPATH}/${file}" $CONFIGPATH >/dev/null 2>&1
        echo "  send: ${file} ... file"
    fi
done
echo ${FIN}
